package jitas.admin;

import javax.swing.JOptionPane;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;


/*
 * NewStudentFrame.java
 *
 * Created on September 13, 2007, 4:11 PM
 */

/**
 *
 * @author  rle41
 */
public class NewStudentFrame extends javax.swing.JFrame {
    
	GUIHelper helper;
	AdminFrame parent;
    /**
	 * 
	 */
	private static final long serialVersionUID = -5750824946773287722L;
	/** Creates new form NewStudentFrame */
    public NewStudentFrame(AdminFrame parent, GUIHelper helper) {
    	this.parent = parent;
    	this.helper = helper;
    	helper.resetNewStudentDomainLists();
        initComponents();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">                          
    private void initComponents() {
        enterUsernameLabel = new javax.swing.JLabel();
        usernameTextField = new javax.swing.JTextField();
        usernameErrorLabel = new javax.swing.JLabel();
        enterPasswordLabel = new javax.swing.JLabel();
        passwordTextField = new javax.swing.JTextField();
        passwordErrorLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        domainList = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        studentDomainList = new javax.swing.JList();
        addDomainButton = new javax.swing.JButton();
        removeDomainButton = new javax.swing.JButton();
        clearDomainButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Create New Student");
        enterUsernameLabel.setText("Enter new Username:");

        usernameErrorLabel.setFont(new java.awt.Font("Bitstream Vera Serif", 3, 12));
        usernameErrorLabel.setForeground(new java.awt.Color(255, 0, 0));
        usernameErrorLabel.setText("jLabel2");

        enterPasswordLabel.setText("Enter Password:");

        passwordErrorLabel.setFont(new java.awt.Font("Bitstream Vera Serif", 3, 12));
        passwordErrorLabel.setForeground(new java.awt.Color(255, 0, 0));
        passwordErrorLabel.setText("jLabel2");

        domainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = 8836583042008654628L;
			String[] strings = helper.getAllDomainNameStrings();
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        

        jScrollPane1.setViewportView(domainList);

        studentDomainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = -3505398707775180788L;
			String[] strings = {};
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });


        jScrollPane2.setViewportView(studentDomainList);

        addDomainButton.setText("Add >");
        addDomainButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addDomainButtonActionPerformed(evt);
            }
        });

        removeDomainButton.setText("< Remove");
        removeDomainButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeDomainButtonActionPerformed(evt);
            }
        });

        clearDomainButton.setText("<< Clear All");
        clearDomainButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearDomainButtonActionPerformed(evt);
            }
        });

        jLabel1.setText("All Domains:");

        jLabel2.setText("Student's Domains:");

        okButton.setText("Create Student");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });
        
        okButton.setEnabled(false);

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });
        
        
        UsernameEntryListener usernameListener = new UsernameEntryListener();
        usernameTextField.getDocument().addDocumentListener(usernameListener);
        usernameListener.setUsernameError(helper.checkUsername(usernameTextField.getText()));
        
        
        PasswordEntryListener passwordListener = new PasswordEntryListener();
        passwordTextField.getDocument().addDocumentListener(passwordListener);
        passwordListener.setPasswordError(helper.checkPassword(passwordTextField.getText()));
        
        
        

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(usernameErrorLabel)
                    .add(passwordErrorLabel)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, enterUsernameLabel)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, enterPasswordLabel)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(5, 5, 5)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel1)
                                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 136, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(20, 20, 20)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(usernameTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 253, Short.MAX_VALUE)
                                    .add(passwordTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 253, Short.MAX_VALUE)))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, removeDomainButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 111, Short.MAX_VALUE)
                                    .add(addDomainButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 111, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, clearDomainButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(layout.createSequentialGroup()
                                        .add(jLabel2)
                                        .add(23, 23, 23))
                                    .add(layout.createSequentialGroup()
                                        .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))))))
                .add(48, 48, 48))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(227, Short.MAX_VALUE)
                .add(okButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(cancelButton)
                .add(31, 31, 31))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(21, 21, 21)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(enterUsernameLabel)
                    .add(usernameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(usernameErrorLabel)
                .add(14, 14, 14)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(enterPasswordLabel)
                    .add(passwordTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(passwordErrorLabel)
                        .add(69, 69, 69)
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(addDomainButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(removeDomainButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 64, Short.MAX_VALUE)
                                .add(clearDomainButton))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)))
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(30, 30, 30)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(okButton)
                    .add(cancelButton))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>                        

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) { 
    	this.dispose();
    }                                        

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {  
    	if (helper.allInputValid()) {
    		try {
    			String newuser = usernameTextField.getText().trim();
    			String newpassword = passwordTextField.getText().trim();
    			
				helper.addNewStudent(newuser, newpassword);
				JOptionPane.showMessageDialog(this, "User \"" + newuser + "\" added successfully", "User Added", JOptionPane.INFORMATION_MESSAGE);
		    	parent.updateAfterNewStudent(newuser);
				this.dispose();
			} catch (Exception e) {
				
				String error = "Something has gone wrong while adding a user to the system.";
				JOptionPane.showMessageDialog(this, error , "Student Data Error", JOptionPane.ERROR_MESSAGE);

			}
    	}
    	
    	
    	
    }                                                                                  

    private void addDomainButtonActionPerformed(java.awt.event.ActionEvent evt) { 
    	
    	int[] selections = domainList.getSelectedIndices();
    	
    	for (int selected: selections) {
    		helper.addDomainToSelectedDomains((String) domainList.getModel().getElementAt(selected));
    	}
    	
    	domainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = -2025425095466366057L;
			String[] strings = helper.getUnselectedDomainStrings();
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        
        studentDomainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = -1814916745478088808L;
			String[] strings = helper.getSelectedDomainStrings();
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        
        if (helper.allInputValid()) {
			okButton.setEnabled(true);
		} else {
			okButton.setEnabled(false);
		}
    	
    }                                               

    private void removeDomainButtonActionPerformed(java.awt.event.ActionEvent evt) { 
    	
    	int[] selections = studentDomainList.getSelectedIndices();
    	
    	for (int selected: selections) {
    		helper.removeDomainFromSelectedDomains((String) studentDomainList.getModel().getElementAt(selected));
    	}
    	
    	domainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = -7364426166539850541L;
			String[] strings = helper.getUnselectedDomainStrings();
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        
        studentDomainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = 2171052821719448110L;
			String[] strings = helper.getSelectedDomainStrings();
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
    	
        if (helper.allInputValid()) {
			okButton.setEnabled(true);
		} else {
			okButton.setEnabled(false);
		}
    	
    }                                                  

    private void clearDomainButtonActionPerformed(java.awt.event.ActionEvent evt) {    
    	helper.resetNewStudentDomainLists();
    	domainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = 2161587571316462214L;
			String[] strings = helper.getAllDomainNameStrings();
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        
        studentDomainList.setModel(new javax.swing.AbstractListModel() {
			private static final long serialVersionUID = 7318856915787727887L;
			String[] strings = {};
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
    	
        if (helper.allInputValid()) {
			okButton.setEnabled(true);
		} else {
			okButton.setEnabled(false);
		}
    }                                                 
    
    
    
    // Variables declaration - do not modify                     
    private javax.swing.JButton addDomainButton;
    private javax.swing.JButton clearDomainButton;
    private javax.swing.JList domainList;
    private javax.swing.JLabel enterPasswordLabel;
    private javax.swing.JLabel enterUsernameLabel;
    private javax.swing.JButton okButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel passwordErrorLabel;
    private javax.swing.JTextField passwordTextField;
    private javax.swing.JButton removeDomainButton;
    private javax.swing.JList studentDomainList;
    private javax.swing.JLabel usernameErrorLabel;
    private javax.swing.JTextField usernameTextField;
    // End of variables declaration                   
    
    
    
    class UsernameEntryListener implements DocumentListener {

		public void changedUpdate(DocumentEvent e) {
			
			
		}

		public void insertUpdate(DocumentEvent e) {
			setUsernameError(helper.checkUsername(usernameTextField.getText().trim()));
		}

		public void removeUpdate(DocumentEvent e) {
			
			
			setUsernameError(helper.checkUsername(usernameTextField.getText().trim()));
		}
		
		public void setUsernameError(String text) {
			
			if (helper.getUsernameEntryStatus()) {
				usernameErrorLabel.setForeground(new java.awt.Color(0, 150, 0));
			} else {
				usernameErrorLabel.setForeground(new java.awt.Color(255, 0, 0));
			}
			
			usernameErrorLabel.setText(text);
			if (helper.allInputValid()) {
				okButton.setEnabled(true);
			} else {
				okButton.setEnabled(false);
			}
		}
    }
    
    class PasswordEntryListener implements DocumentListener {

		public void changedUpdate(DocumentEvent e) {
			
		}

		public void insertUpdate(DocumentEvent e) {
			setPasswordError(helper.checkPassword(passwordTextField.getText()));
		}

		public void removeUpdate(DocumentEvent e) {
			setPasswordError(helper.checkPassword(passwordTextField.getText()));
		}
		
		public void setPasswordError(String text) {
			
			if (helper.getPasswordEntryStatus()) {
				passwordErrorLabel.setForeground(new java.awt.Color(0, 150, 0));
			} else {
				passwordErrorLabel.setForeground(new java.awt.Color(255, 0, 0));
			}
			
			
			passwordErrorLabel.setText(text);
			if (helper.allInputValid()) {
				okButton.setEnabled(true);
			} else {
				okButton.setEnabled(false);
			}
		}
    }
    
    
    
    
    
}
