package jitas.admin;

import java.util.Iterator;
import java.util.SortedSet;
import java.util.TreeSet;

import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

import jitas.core.Admin;

/**
 * Domain information in a table for a specific student
 * @author lsf21 && rle41
 *
 */
public class TableModelCreator {

	SortedSet<String> allDomainNames;
	String student;
	Object[] columns = {"Domain", "Type", "Has Account"};
	Object[][] tableData;
	Admin admin;
	
	public TableModelCreator(Admin admin)  {
		this.admin = admin;
	}
	
		
	public TableModel getModel(String student) {
		this.student = student;
		try {
				if(this.student == null) {
					throw new Exception("the code in exception is the same for in here :)");
				} 
				
				
				allDomainNames = new TreeSet<String>(admin.getAllDomainNames());
				tableData = new Object[allDomainNames.size()][columns.length];
				Iterator<String> iterator = allDomainNames.iterator();
				
				int domainNames = allDomainNames.size();
				
				/*
				 * Setting the values in the Table
				 */
				for (int i = 0; i < domainNames && iterator.hasNext(); i++) {
					String currentDomain = iterator.next();
					try {
						
						tableData[i][0] = currentDomain;
					
						if (admin.userCreationAllowed(currentDomain)) {
							tableData[i][1] = "Unrestricted";
						} else {
							tableData[i][1] = "Restricted";
						}
						
						if (admin.studentHasAccountInDomain(student, currentDomain)) {
							 tableData[i][2] = "Yes";
						} else {
							tableData[i][2] = "No account";
						}
					} catch (Exception ex) {
						--domainNames;
						--i;
					}
				}
				/*
				 * Overloading the isCellEditable method to make cells not 
				 * editable.
				 */
				DefaultTableModel tm = new DefaultTableModel(tableData, columns){
					private static final long serialVersionUID = 5391414263050646844L;
					public boolean isCellEditable(int row, int column) {
						return false;
					}
					
					public Class<? extends Object> getColumnClass(int c) {
			            return getValueAt(0, c).getClass();
			        }
				};
				return tm;
				
			} catch (Exception e) {
				DefaultTableModel tm = new DefaultTableModel() {
					private static final long serialVersionUID = -1068509825989477968L;

					public boolean isCellEditable(int row, int column) {
						return false;
					}
					
					public Class<? extends Object> getColumnClass(int c) {
			            return getValueAt(0, c).getClass();
			        }
				};
				
				tm.setColumnIdentifiers(columns);
				return tm;
			}
		
	}
	
	/**
	 * @param row
	 * @return the domain name from the row
	 */
	public String getDomainNameFromRow(int row) {
		return (String)tableData[row][0];
	}
	
}
